Skip to content
Back to top
View this page

# XEP-0199: XMPP Ping

XEP-0199 on xmpp.org

class slixmpp.plugins.xep_0199.XEP_0199(xmpp, config=None)

  XEP-0199: XMPP Ping

  Given that XMPP is based on TCP connections, it is possible for the underlying connection to be terminated without the application’s awareness. Ping stanzas provide an alternative to whitespace based keepalive methods for detecting lost connections.

  Also see <http://www.xmpp.org/extensions/xep-0199.html>.

  Attributes:
    keepalive – If True, periodically send ping requests

      to the server. If a ping is not answered, the connection will be reset.

    interval – Time in seconds between keepalive pings.

      Defaults to 300 seconds.

    timeout – Time in seconds to wait for a ping response.

      Defaults to 30 seconds.

  Methods:
    send_ping – Send a ping to a given JID, returning the

      round trip time.

  default_config: ClassVar[dict[str, Any]] = {'interval': 300, 'keepalive': False, 'timeout': 30}

    The basic, standard configuration for the plugin, which may be overridden when initializing the plugin. The configuration fields included here may be accessed directly as attributes of the plugin. For example, including the configuration field ‘foo’ would mean accessing plugin.foo returns the current value of plugin.config[‘foo’].

  enable_keepalive(interval=None, timeout=None)

    Enable the ping keepalive on the connection. The plugin will send a ping at interval and reconnect if the ping timeouts.

    Parameters:

      - interval (`float` | `None`) – The interval between each ping

      - timeout (`float` | `None`) – The timeout of the ping

    Return type:

      `None`

  async ping(jid=None, ifrom=None, timeout=None)

    Send a ping request and calculate RTT. This is a coroutine.

    Parameters:

      jid (`JID` | `None`) – The JID that will receive the ping.

    Raises:

      - IqError – When the remote entity answered an error

      - IqTimeout – When the remote entity did not answer

    Return type:

      `float`

  send_ping(jid, ifrom=None, timeout=None, callback=None)

    Send a ping request.

    Parameters:

      jid (`JID`) – The JID that will receive the ping.

    Return type:

      `Future`[`Iq`]

## Stanza elements

class slixmpp.plugins.xep_0199.stanza.Ping(xml=None, parent=None)

  Given that XMPP is based on TCP connections, it is possible for the underlying connection to be terminated without the application’s awareness. Ping stanzas provide an alternative to whitespace based keepalive methods for detecting lost connections.

  Example ping stanza:

      <iq type="get">
        <ping xmlns="urn:xmpp:ping" />
      </iq>

  interfaces: ClassVar[set[str]] = {}

    The set of keys that the stanza provides for accessing and manipulating the underlying XML object. This set may be augmented with the `plugin_attrib` value of any registered stanza plugins.

  name: ClassVar[str] = 'ping'

    The XML tag name of the element, not including any namespace prefixes. For example, an `ElementBase` object for `<message />` would use `name = 'message'`.

  namespace: str = 'urn:xmpp:ping'

    The XML namespace for the element. Given `<foo xmlns="bar" />`, then `namespace = "bar"` should be used. The default namespace is `jabber:client` since this is being used in an XMPP library.

  plugin_attrib: ClassVar[str] = 'ping'

    For `ElementBase` subclasses which are intended to be used as plugins, the `plugin_attrib` value defines the plugin name. Plugins may be accessed by using the `plugin_attrib` value as the interface. An example using `plugin_attrib = 'foo'`:

        register_stanza_plugin(Message, FooPlugin)
        msg = Message()
        msg['foo']['an_interface_from_the_foo_plugin']